/*
 * MathPlanner 3.0.2 - Mathematical design tool.
 * Copyright(C) 2002  Jarmo Nikkanen
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 *
 * You should have received a copy of the GNU General Public License with this program.
 *
 */



// REAL MATH

#include "MathHeaders.h"
#include "Error.h"

#define MODUL_ACCURACY 100000



// This is required to overide same problems than sin & cos have.

bool mpl_modul(double a,double b)
{
double c=(a/b);
double ca=round(c*MODUL_ACCURACY);
double cb=round(c)*MODUL_ACCURACY;

if (ca==cb) return(true);
return(false);
}



double mpl_factorial(double val)
{
double f,i;
if (val!=floor(val)) return(0);
f=1.0;
for(i=1.0;i<=val;i+=1.0) f=f*i;
return(f);
}


double mpl_rad(double deg)
{
return((deg*2/360)*PI);
}


double mpl_deg(double rad)
{
return(360*rad/(2*PI));
}

double mpl_coth(double x)
{
double ex=pow(NEPER,x);
double emx=pow(NEPER,-x);
return((ex+emx)/(ex-emx));
}



double mpl_asinh(double x)
{
return(log(x+sqrt((x*x)+1)));
}



double mpl_acosh(double x)
{
return(log(x+sqrt((x*x)-1)));
}



double mpl_atanh(double x)
{
return(0.5*log((1+x)/(1-x)));
}



double mpl_acoth(double x)
{
return(0.5*log((x+1)/(x-1)));
}





// What are these ? ?   Overiding bugs... maybe
// Sin(x) is only defined in a range of x ( 2pi > x > 0 ) we have to extend that.
// Also Sin(pi) does not return exactly zero so we have to force it to zero.

// This is NOT about unaccurate defination of pi


double mpl_sin(double x)
{
if (x>(2*PI)) x=fmod(x,2*PI);
else if (x<0) x=(2*PI)-fmod(fabs(x),2*PI);

double a=sin(x);

if (a<1e-14 && a>-1e-14) return(0);
return(a);
}




double mpl_cos(double x)
{
if (x>(2*PI)) x=fmod(x,2*PI);
else if (x<0) x=(2*PI)-fmod(fabs(x),2*PI);

double a=cos(x);

if (a<1e-14 && a>-1e-14) return(0);
return(a);
}




