/*
 * MathPlanner 3.0.4 - Mathematical design tool.
 * Copyright(C) 2002  Jarmo Nikkanen
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 *
 * You should have received a copy of the GNU General Public License with this program.
 *
 */





void ApplicationControl::Command(int x)
{
				Paper *pap=parent->GetActivePaper();
        if (pap) pap->CommandToString(STRING_COMMAND_MATH,x);
}



void ApplicationControl::CreateOperatorBar()
{
        int i,x=0;

        for(i=0;i<7;i++) opr_b[x++]=new QToolButton(OperatorBar);
				OperatorBar->addSeparator();
				for(i=0;i<6;i++) opr_b[x++]=new QToolButton(OperatorBar);
				OperatorBar->addSeparator();
				for(i=0;i<3;i++) opr_b[x++]=new QToolButton(OperatorBar);
				OperatorBar->addSeparator();			
        for(i=0;i<5;i++) opr_b[x++]=new QToolButton(OperatorBar);
        OperatorBar->addSeparator();	
				for(i=0;i<6;i++) opr_b[x++]=new QToolButton(OperatorBar);
	
		
        i=0;
        opr_b[i]->setText(QObject::tr("Sqrt")); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TSqrt()));
        opr_b[i]->setText(QObject::tr("Dive")); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TDive()));
        opr_b[i]->setText(QObject::tr("Power")); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TPower()));
        opr_b[i]->setText("Log"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TLog()));
        opr_b[i]->setText("ln"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(Tln()));
        opr_b[i]->setText("Exp"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TExp()));
        opr_b[i]->setText("e"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(Te()));

        opr_b[i]->setText("Min"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TMin()));
        opr_b[i]->setText("Max"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TMax()));
        opr_b[i]->setText("Fact"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TFact()));
        opr_b[i]->setText("Frac"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TFrac()));
        opr_b[i]->setText("Int"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TInt()));
        opr_b[i]->setText("Abs"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TAbs()));

        opr_b[i]->setText("(( ))"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TParA()));
        opr_b[i]->setText("[[ ]]"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TParB()));
        opr_b[i]->setText("{{ }}"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TParC()));

        opr_b[i]->setText("Sigma"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TSigma()));
        opr_b[i]->setText("Pii"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TPii()));
        opr_b[i]->setText("DefFN1"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TDef()));
        opr_b[i]->setText("DefFN2"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TDef2()));
        opr_b[i]->setText("DefFN3"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TDef3()));

        opr_b[i]->setText("Sin"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TSin()));
        opr_b[i]->setText("Cos"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TCos()));
        opr_b[i]->setText("Tan"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TTan()));
        opr_b[i]->setText("aSin"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TaSin()));
        opr_b[i]->setText("aCos"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TaCos()));
        opr_b[i]->setText("aTan"); connect(opr_b[i++],SIGNAL(clicked()),this,SLOT(TaTan()));



}

void ApplicationControl::CreateComplexBar()
{
        int i,x=0;

        for(i=0;i<7;i++) opr_c[x++]=new QToolButton(ComplexBar);
				ComplexBar->addSeparator();
				for(i=0;i<5;i++) opr_c[x++]=new QToolButton(ComplexBar);
				ComplexBar->addSeparator();
				for(i=0;i<1;i++) opr_c[x++]=new QToolButton(ComplexBar);
				
        i=0;
        opr_c[i]->setText(" i "); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TImaginary()));
        opr_c[i]->setText("/__"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TCAng()));
        opr_c[i]->setText("arg z"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TArg()));
        opr_c[i]->setText("mod z"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TModul()));
        opr_c[i]->setText("Z*"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TConj()));
        opr_c[i]->setText("Re z"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TRez()));
        opr_c[i]->setText("Im z"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TImz()));


        opr_c[i]->setText(" i "); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TVectI()));
        opr_c[i]->setText(" j "); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TVectJ()));
        opr_c[i]->setText(" k "); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TVectK()));
        opr_c[i]->setText("len"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TVLen()));
        opr_c[i]->setText("cross"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TVCross()));

        opr_c[i]->setText("unit");  opr_c[i]->setEnabled(false);
        connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TUnit()));



        /*
        opr_c[i]->setText("nxm"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TParA()));
        opr_c[i]->setText("1x3"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TParB()));
        opr_c[i]->setText("2x2"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TParC()));
        opr_c[i]->setText("3x3"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TSigma()));
        opr_c[i]->setText("Det"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TPii()));
        opr_c[i]->setText("Trans"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TDef()));
        opr_c[i]->setText("Inv"); connect(opr_c[i++],SIGNAL(clicked()),this,SLOT(TSin()));
        */
}

void ApplicationControl::TSqrt() { Command(T_SQRT);  }
void ApplicationControl::TDive() { Command(T_DIVE);  }
void ApplicationControl::TPower() { Command(T_POWER); }
void ApplicationControl::TLog() { Command(T_LOG); }
void ApplicationControl::Tln() { Command(T_LN); }
void ApplicationControl::TExp() { Command(T_EXP); }
void ApplicationControl::Te() { Command(T_E); }
void ApplicationControl::TMin() { Command(T_MIN); }
void ApplicationControl::TMax() { Command(T_MAX); }

void ApplicationControl::TAbs() { Command(T_ABS); }
void ApplicationControl::TParA() { Command(T_PAR_A); }
void ApplicationControl::TParB() { Command(T_PAR_B); }
void ApplicationControl::TParC() { Command(T_PAR_C); }

void ApplicationControl::TSin() { Command(T_SIN); }
void ApplicationControl::TCos() { Command(T_COS); }
void ApplicationControl::TTan() { Command(T_TAN); }
void ApplicationControl::TCot() { Command(T_COT); }
void ApplicationControl::TaSin() { Command(T_ASIN); }
void ApplicationControl::TaCos() { Command(T_ACOS); }
void ApplicationControl::TaTan() { Command(T_ATAN); }
void ApplicationControl::TaCot() { Command(T_ACOT); }

void ApplicationControl::TFact() { Command(T_FACTORIAL); }
void ApplicationControl::TFrac() { Command(T_FRAC); }
void ApplicationControl::TInt() { Command(T_INT); }

void ApplicationControl::TSigma() { Command(T_SIGMA); }
void ApplicationControl::TPii() { Command(T_BIG_PII); }
void ApplicationControl::TDef() { Command(T_FUNCTION_DEF); }
void ApplicationControl::TDef2() { Command(T_FUNCTION_DEF_2); }
void ApplicationControl::TDef3() { Command(T_FUNCTION_DEF_3); }

void ApplicationControl::TVLen() { Command(T_LENGTH); }
void ApplicationControl::TVCross() { Command(T_CROSS); }
void ApplicationControl::TConj() { Command(T_CONJUGANT); }

void ApplicationControl::TUnit() { Command(T_UNIT); }

void ApplicationControl::TPiiConst() {
     Paper *pap=parent->GetActivePaper();
     QKeyEvent key(QEvent::KeyPress,0,GREEK_pii,0,QString(QChar(GREEK_pii)));
     if (pap) pap->keyPressEvent(&key);
}

// COMPLEX

void ApplicationControl::TImaginary() { Command(T_IMAGINARY); }
void ApplicationControl::TVectI() { Command(T_VECTOR_I); }
void ApplicationControl::TVectJ() { Command(T_VECTOR_J); }
void ApplicationControl::TVectK() { Command(T_VECTOR_K); }

void ApplicationControl::TArg() { Command(T_ARG_Z); }
void ApplicationControl::TModul() { Command(T_MODUL_Z); }
void ApplicationControl::TRez() { Command(T_REZ); }
void ApplicationControl::TImz() { Command(T_IMZ); }
void ApplicationControl::TCAng() { Command(T_COMPLEX_A); }
